
var SPLASH = {
	
	progress: 0,
	
	totalUnits: 0,
	
	container: null,
	
	progressBar: null,
	
	resized: false,
	
	size: {width:300, height:60},
	
	isIE : function() {
		var ua = navigator.userAgent.toLowerCase();
		var isOpera = ua.indexOf('opera') > -1; 
		var isIE = !isOpera && ua.indexOf('msie') > -1;
		return isIE;
	},
	
	getWindowWidth: function() {
		return 	parseInt(window.innerWidth) || 
				parseInt(document.body.clientWidth) || 
				parseInt(document.documentElement.clientWidth);
	},
	
	getWindowHeight: function() {
		return 	parseInt(window.innerHeight) || 
				parseInt(document.body.clientHeight) || 
				parseInt(document.documentElement.clientHeight);
	},
	    
    getProgressBar : function() {
    	if(!SPLASH.progressBar) {        		
			var progressBar = document.getElementById('splash-indicator');
			progressBar.style.opacity = '0.7';
			progressBar.style.filter = 'alpha(opacity=70)';
			if(SPLASH.isIE()) {
				//accommodate parent's borders by subtracting 
				// the border widths from the height
				progressBar.style.height = "21px";
			} 
			SPLASH.progressBar = progressBar;        		
		} 
    	return SPLASH.progressBar;
    },
    
    resize : function() {
    	if(!SPLASH.resized) {
	    	var w = SPLASH.getWindowWidth();
			var h = SPLASH.getWindowHeight();                        
			var container = document.getElementById('splash-container');
			container.style.position = 'absolute';
			container.style.top = ((h*.5)-(SPLASH.size.height*.5)) + 'px';
			container.style.left = ((w*.5)-(SPLASH.size.width*.5)) + 'px';
			container.style.width = SPLASH.size.width + "px";
			container.style.height = SPLASH.size.height + "px";
			container.style.display = 'block';
			SPLASH.resized = true;			
    	}
    },
    
    setSize : function(width, height) {
    	SPLASH.size.width = width;
    	SPLASH.size.height = height;
    	SPLASH.resize();
    },
    
    setImage : function(url) {
    	var img = document.createElement("IMG");
    	img.src = url;
    	img.style.visibility = "hidden";
    	img.onload = function(){SPLASH.onImageLoaded(this);};
    	document.body.appendChild(img);		
    },
    
    onImageLoaded : function(img) {
        var width = Math.max(parseInt(img.offsetWidth), SPLASH.size.width);
		var height = Math.max(parseInt(img.offsetHeight), 50);
		document.body.removeChild(img);
		img.style.visibility = "visible";
		
		//increase splash size by IMG width/height
		SPLASH.setSize(width, SPLASH.size.height + height);
		var logo = document.getElementById("splash-image");
		logo.appendChild(img);
		logo.style.height = height + "px";
    },
	
	setTaskName : function(msg) {
		if(typeof(msg) == 'string') {
			document.getElementById('splash-msg').innerHTML = msg;
		}                         
	}, 
	
	setTotalUnits: function(count) {
		SPLASH.totalUnits = count;
	},
	
	setTitle : function(title) {
		document.getElementById("splash-title").innerHTML = title;
	},
	
	worked : function(msg) {
		++SPLASH.progress;                            
		try {
			SPLASH.resize();			
			var perc = SPLASH.progress/SPLASH.totalUnits;
			var progressBar = SPLASH.getProgressBar();			
			var maxWidth = SPLASH.size.width - (SPLASH.isIE() ? 4 : 2);
			progressBar.style.width = (maxWidth * perc) + 'px';
			progressBar.innerHTML = Math.floor(perc*100) + '%';
			SPLASH.setTaskName(msg);
		} catch(e) {}
		if(SPLASH.progress >= SPLASH.totalUnits) {
			SPLASH.doComplete();
		}
	},
	
	doComplete : function() {
    	SPLASH.dispose();
	}, 
	
	dispose : function() {
		//async'ly remove the splash divs from the window
		// don't do it inline or else it will be noticable to the user
		setTimeout(function(){
			var container = document.getElementById("splash-container");
			if(container) container.parentNode.removeChild(container);
		}, 10000);
		for(var k in SPLASH) {	
			delete SPLASH[k];			
		}
		window.SPLASH = null;
	}
};